import java.io.IOException;



public class ReThrowAfterSE7 {

	public static void rethrowWrapping() throws IOException {
		try {
			throw new IOException("It is a checked exception!");
		}
		catch(Exception exception) {
			//Do some handling and then re-throw:
			throw exception;
		}
	}

	static class FirstException extends Exception {
		 
		public FirstException(String message) {
			super(message);
		} 
		}
	static class SecondException extends Exception {
		
		public SecondException(String message) {
			super(message);
		} 
	}

	public static void rethrowTwoChildren(String exceptionName) throws FirstException, SecondException {
		try {
			if (exceptionName.equals("First")) {
				throw new FirstException("It is First");
			} else {
				throw new SecondException("It is Second");
			}
		} catch (Exception e) {
			throw e;
		}
	}

	public static void main( String[] args ) throws FirstException, SecondException  {
		try {
			rethrowWrapping();
		}
		catch(IOException exception) {
			System.err.println(exception.getMessage());
		}
		try {
			rethrowTwoChildren("First");
		}
		catch(Exception ex) {
			// I can declare throws of children in the "main" signature 
			System.err.println(ex.getMessage());
		}
	}
}
